require "util"
--require "story"
require "defines"



game.oninit(function()

  --[[game.player.character.insert{name="farm",count=8}
  game.player.character.insert{name="small-electric-pole",count=64}
  game.player.character.insert{name="basic-inserter",count=32}
  game.player.character.insert{name="wooden-chest",count=32}
  game.player.character.insert{name="basic-transport-belt",count=192}
  game.player.character.insert{name="solar-panel",count=64}
  game.player.character.insert{name="raw-wood",count=256}
  game.player.character.insert{name="food-maker",count=8}
  game.player.character.insert{name="tomacco",count=320}
  game.player.character.insert{name="col-money",count=3000}
  game.player.character.insert{name="goods-maker",count=8}
  game.player.character.insert{name="tools",count=100}
  game.player.character.insert{name="cargo-pad",count=8}
  game.player.character.insert{name="seeds",count=256}
  game.player.character.insert{name="outpost",count=8}
  game.player.character.insert{name="merchant",count=8}
  game.player.character.insert{name="acropolis",count=8}
  game.player.character.insert{name="food",count=300}
  game.player.character.insert{name="colonist-token",count=100}
  game.player.character.insert{name="stone-furnace",count=8}
  game.player.character.insert{name="coal",count=128}
  game.player.character.insert{name="iron-ore",count=256}
  game.player.character.insert{name="smart-inserter",count=64}
  game.player.character.insert{name="red-wire",count=128}
  game.player.character.insert{name="green-wire",count=128}
  game.player.character.insert{name="goods1",count=256}
  game.player.character.insert{name="goods3",count=64}
  game.player.character.insert{name="goods2",count=128}
  game.player.character.insert{name="trading-goods",count=128}]]


  glob.colonization = {}
  glob.colonization.outposts = {}
  glob.colonization.outposts.intro = true
  glob.colonization.outposts.foodCounter = {}
  glob.colonization.outposts.goodsCounter = {}
  glob.colonization.outpostCount = 0

  glob.colonization.merchant = {}
  glob.colonization.merchant.intro = true
  glob.colonization.merchant.foodCounter = {}
  glob.colonization.merchant.goodsCounter1 = {}
  glob.colonization.merchant.goodsCounter2 = {}
  glob.colonization.merchantCount = 0

  glob.colonization.acropolis = {}
  glob.colonization.acropolis.intro = true
  glob.colonization.acropolis.foodCounter = {}
  glob.colonization.acropolis.goodsCounter1 = {}
  glob.colonization.acropolis.goodsCounter2 = {}
  glob.colonization.acropolis.goodsCounter3 = {}
  glob.colonization.acropolisCount = 0

  glob.colonization.tickCounter = {}
  glob.colonization.tickCounter.outposts = 0

end)

game.onload(function()
  if glob.colonization == nil then
    glob.colonization = {}
    glob.colonization.outposts = {}
    glob.colonization.outposts.intro = true
    glob.colonization.outposts.foodCounter = {}
    glob.colonization.outposts.goodsCounter = {}
    glob.colonization.outpostCount = 0

    glob.colonization.merchant = {}
    glob.colonization.merchant.intro = true
    glob.colonization.merchant.foodCounter = {}
    glob.colonization.merchant.goodsCounter1 = {}
    glob.colonization.merchant.goodsCounter2 = {}
    glob.colonization.merchantCount = 0

    glob.colonization.acropolis = {}
    glob.colonization.acropolis.intro = true
    glob.colonization.acropolis.foodCounter = {}
    glob.colonization.acropolis.goodsCounter1 = {}
    glob.colonization.acropolis.goodsCounter2 = {}
    glob.colonization.acropolis.goodsCounter3 = {}
    glob.colonization.acropolisCount = 0

    glob.colonization.tickCounter = {}
    glob.colonization.tickCounter.outposts = 0
  end
end)

game.onevent(defines.events.onbuiltentity, function(event)

  if (event.createdentity.name == "outpost") and (glob.colonization.outposts.intro == true) and (glob.colonization.outpostCount == 0) then
    outpostIntro()                                                                         -- checks if building needs introduction-msg
    glob.colonization.outposts.intro = false
  end

  if (event.createdentity.name == "merchant") and (glob.colonization.merchant.intro == true) and (glob.colonization.merchantCount == 0) then
    merchantIntro()                                                                         -- checks if building needs introduction-msg
    glob.colonization.merchant.intro = false
  end

  if (event.createdentity.name == "acropolis") and (glob.colonization.acropolis.intro == true) and (glob.colonization.acropolisCount == 0) then
    acropolisIntro()                                                                         -- checks if building needs introduction-msg
    glob.colonization.acropolis.intro = false
  end

  if event.createdentity.name == "outpost" then
    glob.colonization.outpostCount = glob.colonization.outpostCount + 1    
    glob.colonization.outposts[glob.colonization.outpostCount] = event.createdentity    -- stores the built outpost-entity in the table
    glob.colonization.outposts.foodCounter[glob.colonization.outpostCount] = 0
  end

  if event.createdentity.name == "merchant" then
    glob.colonization.merchantCount = glob.colonization.merchantCount + 1    
    glob.colonization.merchant[glob.colonization.merchantCount] = event.createdentity    -- stores the built merchant-entity in the table
    glob.colonization.merchant.foodCounter[glob.colonization.merchantCount] = 0
  end

  if event.createdentity.name == "acropolis" then
    glob.colonization.acropolisCount = glob.colonization.acropolisCount + 1    
    glob.colonization.acropolis[glob.colonization.acropolisCount] = event.createdentity    -- stores the built acropolis-entity in the table
    glob.colonization.acropolis.foodCounter[glob.colonization.acropolisCount] = 0
  end
end) -- game.onevent(defines.events.onbuiltentity, function(event)


game.onevent(defines.events.ontick, function(event)

  glob.colonization.tickCounter.outposts = glob.colonization.tickCounter.outposts + 1


  outpostCheckValid()                                                                    -- checks if all built outposts still valid
  merchantCheckValid()                                                                   -- checks if all built merchants still valid
  acropolisCheckValid()                                                                  -- checks if all built acropolis still valid

  if (glob.colonization.tickCounter.outposts % 720) == 0 then                          -- food,garbage, etc. procedure called every 12 seconds
    outpostMaintain()
    merchantMaintain()
    acropolisMaintain()
  end

  if (glob.colonization.tickCounter.outposts % 60) == 0 then                              -- production-procedure called every second
    outpostProd()
  end

  if (glob.colonization.tickCounter.outposts % 120) == 0 then                              -- production-procedure called every 2 seconds
    merchantProd()
  end

  if (glob.colonization.tickCounter.outposts % 7200) == 0 then                         -- tax-procedure called every 2 minutes
    acropolisTaxes()
  end

    if (glob.colonization.tickCounter.outposts % 3600) == 0 then                         -- transform-function called every minute
    outpostTransform()
    merchantTransform()
  end
      
end)


-------------FUNCTIONS------------------------------------

outpostIntro = 
  function()
    game.showmessagedialog(game.gettext("msg_outpostIntro"))
  end

merchantIntro =
  function ()
    game.showmessagedialog(game.gettext("msg_merchantIntro"))
  end

acropolisIntro =
  function ()
    game.showmessagedialog(game.gettext("msg_acropolisIntro"))
  end

outpostCheckValid =
  function()
    for i = 1 , glob.colonization.outpostCount , 1 do                                   -- run trough all outpost-entities
      local outpostExists = glob.colonization.outposts[i].isvalid()                           -- actual outpost exists?
      if outpostExists == false then                                                   -- nope,
        for j = i , glob.colonization.outpostCount - 1 do                               -- "shift all existing entities 1 postion down"
          glob.colonization.outposts[j]=glob.colonization.outposts[j + 1]               -- => the invalid outpost-entity is removed
        end
        glob.colonization.outpostCount = glob.colonization.outpostCount - 1
      end
    end
  end

outpostMaintain =
  function()
    for i = 1 , glob.colonization.outpostCount , 1 do   
      if glob.colonization.outposts[i].getitemcount("colonist-token") > 10 then
        game.player.print("Too many colonists in an outpost! Max. population = 10")
        glob.colonization.outposts.foodCounter[i] = glob.colonization.outposts.foodCounter[i] + 2
        if glob.colonization.outposts.foodCounter[i] >= 10 then
          game.player.print("Overpopulation! Colonist died!!!")
          glob.colonization.outposts[i].getinventory(1).remove{name="colonist-token", count = 1}
        end
      end

      if glob.colonization.outposts[i].getitemcount("garbage") > 100 then
        game.player.print("Too much garbage in an outpost!")
        glob.colonization.outposts.foodCounter[i] = glob.colonization.outposts.foodCounter[i] + 2
      else
        local garbage = math.ceil(glob.colonization.outposts[i].getitemcount("colonist-token") / 2)
        if garbage > 0 then
          if glob.colonization.outposts[i].getinventory(1).caninsert{name="garbage" , count = garbage} == false then
            glob.colonization.outposts.foodCounter[i] = glob.colonization.outposts.foodCounter[i] + 2
            game.player.print("Can not extract the garbage in an outpost! Inventory full!")
          end
          glob.colonization.outposts[i].getinventory(1).insert{name="garbage", count = garbage}
        end
        if glob.colonization.outposts.foodCounter[i] >= 10 then
          game.player.print("Colonist died caused by polution!!!")
          glob.colonization.outposts[i].getinventory(1).remove{name="colonist-token", count = 1}
        end
      end

      if glob.colonization.outposts[i].getitemcount("food") >= glob.colonization.outposts[i].getitemcount("colonist-token") then
        local allFood = glob.colonization.outposts[i].getitemcount("colonist-token")
        if allFood > 0 then
          glob.colonization.outposts[i].getinventory(1).remove{name="food", count = allFood}
        end
        if glob.colonization.outposts.foodCounter[i] > 0 then
          glob.colonization.outposts.foodCounter[i] = glob.colonization.outposts.foodCounter[i] - 1
        end
      else
        if glob.colonization.outposts.foodCounter[i] < 10 then
          glob.colonization.outposts.foodCounter[i] = glob.colonization.outposts.foodCounter[i] + 1
          if glob.colonization.outposts[i].getitemcount("food") > 0 then
            glob.colonization.outposts[i].getinventory(1).remove{name="food", count = glob.colonization.outposts[i].getitemcount("food")}
          end
          game.player.print("Not enough food in an outpost!")
        else
          game.player.print("Not enough food in an outpost! Colonist died!!!")
          glob.colonization.outposts[i].getinventory(1).remove{name="colonist-token", count = 1}
          glob.colonization.outposts.foodCounter[i] = 0
        end
      end
    end
  end

outpostTransform =
  function()
    for i = 1 , glob.colonization.outpostCount , 1 do
      if glob.colonization.outposts[i].getitemcount("colonist-token") > 0 and glob.colonization.outposts[i].getitemcount("goods1") >= 10 then
        local rnd = math.random()
        if rnd > 0.75 then
          glob.colonization.outposts[i].getinventory(1).remove{name="colonist-token", count = 1}
          glob.colonization.outposts[i].getinventory(1).remove{name="goods1", count = 10}
          glob.colonization.outposts[i].getinventory(1).insert{name="settler-token", count = 1}
          game.player.print("Colonist was converted into settler!")
        end
      end
    end
  end

outpostProd =
  function()
    for i = 1 , glob.colonization.outpostCount , 1 do
      if (glob.colonization.outposts[i].getitemcount("colonist-token") > 0) then
        local colonistsCount = glob.colonization.outposts[i].getitemcount("colonist-token")
        local toolsCount = glob.colonization.outposts[i].getitemcount("tools")
        local ironOre = glob.colonization.outposts[i].getitemcount("iron-ore")
        local copperOre = glob.colonization.outposts[i].getitemcount("copper-ore")
        
        if (ironOre > colonistsCount) and (toolsCount > (math.floor(colonistsCount / 5) + 1)) then
          glob.colonization.outposts[i].getinventory(1).remove{name="iron-ore", count = colonistsCount}
          glob.colonization.outposts[i].getinventory(1).remove{name="tools", count = (math.floor(colonistsCount / 5) + 1)}
          glob.colonization.outposts[i].getinventory(1).insert{name="iron-plate", count = colonistsCount}
        elseif (copperOre > colonistsCount) and (toolsCount > (math.floor(colonistsCount / 5) + 1)) then
          glob.colonization.outposts[i].getinventory(1).remove{name="copper-ore", count = colonistsCount}
          glob.colonization.outposts[i].getinventory(1).remove{name="tools", count = (math.floor(colonistsCount / 5) + 1)}
          glob.colonization.outposts[i].getinventory(1).insert{name="copper-plate", count = colonistsCount}
        end
      end
    end
  end

merchantCheckValid =
  function()
    for i = 1 , glob.colonization.merchantCount , 1 do                                   -- run trough all merchant-entities
      local merchantExists = glob.colonization.merchant[i].isvalid()                           -- actual merchant exists?
      if merchantExists == false then                                                   -- nope,
        for j = i , glob.colonization.merchantCount - 1 do                               -- "shift all existing entities 1 postion down"
          glob.colonization.merchant[j]=glob.colonization.merchant[j + 1]               -- => the invalid merchant-entity is removed
        end
        glob.colonization.merchantCount = glob.colonization.merchantCount - 1
      end
    end
  end

merchantMaintain =
  function()
    for i = 1 , glob.colonization.merchantCount , 1 do
      
      if glob.colonization.merchant[i].getitemcount("settler-token") > 20 then                       -- population
        game.player.print("Too many settlers in a merchant-settlement! Max. population = 20")
        glob.colonization.merchant.foodCounter[i] = glob.colonization.merchant.foodCounter[i] + 2
        if glob.colonization.merchant.foodCounter[i] >= 10 then
          game.player.print("Overpopulation! Settler died!!!")
          glob.colonization.merchant[i].getinventory(1).remove{name="settler-token", count = 1}
        end
      end

      if glob.colonization.merchant[i].getitemcount("garbage") > 200 then                            -- garbage
        game.player.print("Too much garbage in a merchant-settlement!")
        glob.colonization.merchant.foodCounter[i] = glob.colonization.merchant.foodCounter[i] + 2
      else
        local garbage = (math.ceil(glob.colonization.merchant[i].getitemcount("settler-token") / 3)) * 2      -- 1 settler == 2/3 garbage
        if garbage > 0 then
          if glob.colonization.merchant[i].getinventory(1).caninsert{name="garbage" , count = garbage} == false then
            glob.colonization.merchant.foodCounter[i] = glob.colonization.merchant.foodCounter[i] + 2
            game.player.print("Can not extract the garbage in a merchant-settlement! Inventory full!")
          end
          glob.colonization.merchant[i].getinventory(1).insert{name="garbage", count = garbage}
        end
        if glob.colonization.merchant.foodCounter[i] >= 10 then
          game.player.print("Settler died caused by polution!!!")
          glob.colonization.merchant[i].getinventory(1).remove{name="settler-token", count = 1}
        end
      end

      if glob.colonization.merchant[i].getitemcount("food") >= glob.colonization.merchant[i].getitemcount("settler-token") then     -- food
        local allFood = glob.colonization.merchant[i].getitemcount("settler-token")
        if allFood > 0 then
          glob.colonization.merchant[i].getinventory(1).remove{name="food", count = allFood}
        end
        if glob.colonization.merchant.foodCounter[i] > 0 then
          glob.colonization.merchant.foodCounter[i] = glob.colonization.merchant.foodCounter[i] - 1
        end
      else
        if glob.colonization.merchant.foodCounter[i] < 10 then
          glob.colonization.merchant.foodCounter[i] = glob.colonization.merchant.foodCounter[i] + 1
          if glob.colonization.merchant[i].getitemcount("food") > 0 then
            glob.colonization.merchant[i].getinventory(1).remove{name="food", count = glob.colonization.merchant[i].getitemcount("food")}
          end
          game.player.print("Not enough food in a merchant-settlement!")
        else
          game.player.print("Not enough food in a merchant-settlement! Settler died!!!")
          glob.colonization.merchant[i].getinventory(1).remove{name="settler-token", count = 1}
          glob.colonization.merchant.foodCounter[i] = 0
        end
      end

      if glob.colonization.merchant[i].getitemcount("settler-token") > 0 then                       -- goods
        local goods1 = glob.colonization.merchant[i].getitemcount("goods1")
        local goods2 = glob.colonization.merchant[i].getitemcount("goods2")
        local settler = glob.colonization.merchant[i].getitemcount("settler-token")
        local missingGoods = 0

        if glob.colonization.merchant.goodsCounter1[i] == nil then
          glob.colonization.merchant.goodsCounter1[i] = 0
        end
        if glob.colonization.merchant.goodsCounter2[i] == nil then
          glob.colonization.merchant.goodsCounter2[i] = 0
        end

        local goodsNeeded = math.ceil(settler * 0.25)
        if goodsNeeded <= goods1 then
          glob.colonization.merchant.goodsCounter1[i] = glob.colonization.merchant.goodsCounter1[i] - 1
        else
          glob.colonization.merchant.goodsCounter1[i] = glob.colonization.merchant.goodsCounter1[i] + 1
          game.player.print("Not enough goods in a merchant-settlement!")
        end
          glob.colonization.merchant[i].getinventory(1).remove{name="goods1", count = goodsNeeded}

        --[[goodsNeeded = math.ceil(citizen * 0.1)
        if goodsNeeded <= goods2 then
          glob.colonization.merchant.goodsCounter2[i] = glob.colonization.merchant.goodsCounter2[i] - 1
        else
          glob.colonization.merchant.goodsCounter2[i] = glob.colonization.merchant.goodsCounter2[i] + 1
          game.player.print("Not enough goods in a merchant-settlement!")
        end
        glob.colonization.merchant[i].getinventory(1).remove{name="goods2", count = goodsNeeded}]]

        if (glob.colonization.merchant.goodsCounter1[i] >= 7) --[[or (glob.colonization.merchant.goodsCounter2[i] >= 10)]] then
          missingGoods = missingGoods + 1
        end

        if missingGoods > 0 then
          game.player.print("Not enough goods in a merchant-settlement! Settler converted!!!")
          glob.colonization.merchant[i].getinventory(1).remove{name="settler-token", count = 1}
          glob.colonization.merchant[i].getinventory(1).insert{name="colonist-token", count = 1}
          glob.colonization.merchant.goodsCounter1[i] = 0
          --[[glob.colonization.merchant.goodsCounter2[i] = 0]]
          missingGoods = 0
        end       
      end -- glob.colonization.merchant[i].getitemcount("citizen-token") > 0 then
    end -- for i = 1 , glob.colonization.merchantCount , 1 do
  end -- function

merchantProd =
  function()
    for i = 1 , glob.colonization.merchantCount , 1 do
      if (glob.colonization.merchant[i].getitemcount("settler-token") > 0) then
        local settlerCount = glob.colonization.merchant[i].getitemcount("settler-token")
        local toolsCount = glob.colonization.merchant[i].getitemcount("tools")
        local ironPlate = glob.colonization.merchant[i].getitemcount("iron-plate")
        local copperPlate = glob.colonization.merchant[i].getitemcount("copper-plate")
        
        if (ironPlate > settlerCount) and (toolsCount > (math.floor(settlerCount / 10) + 1)) then
          glob.colonization.merchant[i].getinventory(1).remove{name="iron-plate", count = settlerCount}
          glob.colonization.merchant[i].getinventory(1).remove{name="tools", count = (math.floor(settlerCount / 10) + 1)}
          glob.colonization.merchant[i].getinventory(1).insert{name="trading-goods", count = settlerCount}
        elseif (copperPlate > settlerCount) and (toolsCount > (math.floor(settlerCount / 10) + 1)) then
          glob.colonization.merchant[i].getinventory(1).remove{name="copper-plate", count = settlerCount}
          glob.colonization.merchant[i].getinventory(1).remove{name="tools", count = (math.floor(settlerCount / 10) + 1)}
          glob.colonization.merchant[i].getinventory(1).insert{name="trading-goods", count = settlerCount}
        end
      end
    end
  end

merchantTransform =
  function()
    for i = 1 , glob.colonization.merchantCount , 1 do
      if (glob.colonization.merchant[i].getitemcount("settler-token") > 0) and (glob.colonization.merchant[i].getitemcount("goods1") >= 20) and
        (glob.colonization.merchant[i].getitemcount("goods2") >= 10) then
        local rnd = math.random()
        if rnd > 0.75 then
          glob.colonization.merchant[i].getinventory(1).remove{name="settler-token", count = 1}
          glob.colonization.merchant[i].getinventory(1).remove{name="goods1", count = 20}
          glob.colonization.merchant[i].getinventory(1).remove{name="goods2", count = 10}
          glob.colonization.merchant[i].getinventory(1).insert{name="citizen-token", count = 1}
          game.player.print("Settler was converted into citizen!")
        end
      end
    end
  end

acropolisCheckValid =
  function()
    for i = 1 , glob.colonization.acropolisCount , 1 do                                   -- run trough all acropolis-entities
      local acropolisExists = glob.colonization.acropolis[i].isvalid()                           -- actual acropolis exists?
      if acropolisExists == false then                                                   -- nope,
        for j = i , glob.colonization.acropolisCount - 1 do                               -- "shift all existing entities 1 postion down"
          glob.colonization.acropolis[j]=glob.colonization.acropolis[j + 1]               -- => the invalid acropolis-entity is removed
        end
        glob.colonization.acropolisCount = glob.colonization.acropolisCount - 1
      end
    end
  end

acropolisMaintain =
  function()
    for i = 1 , glob.colonization.acropolisCount , 1 do
      
      if glob.colonization.acropolis[i].getitemcount("citizen-token") > 50 then                       -- population
        game.player.print("Too many citizens in an acropolis! Max. population = 50")
        glob.colonization.acropolis.foodCounter[i] = glob.colonization.acropolis.foodCounter[i] + 2
        if glob.colonization.acropolis.foodCounter[i] >= 10 then
          game.player.print("Overpopulation! Citizen died!!!")
          glob.colonization.acropolis[i].getinventory(1).remove{name="citizen-token", count = 1}
        end
      end

      if glob.colonization.acropolis[i].getitemcount("garbage") > 400 then                            -- garbage
        game.player.print("Too much garbage in an acropolis!")
        glob.colonization.acropolis.foodCounter[i] = glob.colonization.acropolis.foodCounter[i] + 2
      else
        local garbage = glob.colonization.acropolis[i].getitemcount("citizen-token")
        if garbage > 0 then
          if glob.colonization.acropolis[i].getinventory(1).caninsert{name="garbage" , count = garbage} == false then
            glob.colonization.acropolis.foodCounter[i] = glob.colonization.acropolis.foodCounter[i] + 2
            game.player.print("Can not extract the garbage in an acropolis! Inventory full!")
          end
          glob.colonization.acropolis[i].getinventory(1).insert{name="garbage", count = garbage}
        end
        if glob.colonization.acropolis.foodCounter[i] >= 10 then
          game.player.print("Citizen died caused by polution!!!")
          glob.colonization.acropolis[i].getinventory(1).remove{name="citizen-token", count = 1}
        end
      end

      if glob.colonization.acropolis[i].getitemcount("food") >= glob.colonization.acropolis[i].getitemcount("citizen-token") then     -- food
        local allFood = glob.colonization.acropolis[i].getitemcount("citizen-token")
        if allFood > 0 then
          glob.colonization.acropolis[i].getinventory(1).remove{name="food", count = allFood}
        end
        if glob.colonization.acropolis.foodCounter[i] > 0 then
          glob.colonization.acropolis.foodCounter[i] = glob.colonization.acropolis.foodCounter[i] - 1
        end
      else
        if glob.colonization.acropolis.foodCounter[i] < 10 then
          glob.colonization.acropolis.foodCounter[i] = glob.colonization.acropolis.foodCounter[i] + 1
          if glob.colonization.acropolis[i].getitemcount("food") > 0 then
            glob.colonization.acropolis[i].getinventory(1).remove{name="food", count = glob.colonization.acropolis[i].getitemcount("food")}
          end
          game.player.print("Not enough food in an acropolis!")
        else
          game.player.print("Not enough food in an acropolis! Citizen died!!!")
          glob.colonization.acropolis[i].getinventory(1).remove{name="citizen-token", count = 1}
          glob.colonization.acropolis.foodCounter[i] = 0
        end
      end

      if glob.colonization.acropolis[i].getitemcount("citizen-token") > 0 then                       -- goods
        local goods1 = glob.colonization.acropolis[i].getitemcount("goods1")
        local goods2 = glob.colonization.acropolis[i].getitemcount("goods2")
        local goods3 = glob.colonization.acropolis[i].getitemcount("goods3")
        local citizen = glob.colonization.acropolis[i].getitemcount("citizen-token")
        local missingGoods = 0

        if glob.colonization.acropolis.goodsCounter1[i] == nil then
          glob.colonization.acropolis.goodsCounter1[i] = 0
        end
        if glob.colonization.acropolis.goodsCounter2[i] == nil then
          glob.colonization.acropolis.goodsCounter2[i] = 0
        end
        if glob.colonization.acropolis.goodsCounter3[i] == nil then
          glob.colonization.acropolis.goodsCounter3[i] = 0
        end

        local goodsNeeded = math.ceil(citizen * 0.5)
        if goodsNeeded <= goods1 then
          glob.colonization.acropolis.goodsCounter1[i] = glob.colonization.acropolis.goodsCounter1[i] - 1
        else
          glob.colonization.acropolis.goodsCounter1[i] = glob.colonization.acropolis.goodsCounter1[i] + 1
          game.player.print("Not enough goods in an acropolis!")
        end
          glob.colonization.acropolis[i].getinventory(1).remove{name="goods1", count = goodsNeeded}

        goodsNeeded = math.ceil(citizen * 0.25)
        if goodsNeeded <= goods2 then
          glob.colonization.acropolis.goodsCounter2[i] = glob.colonization.acropolis.goodsCounter2[i] - 1
        else
          glob.colonization.acropolis.goodsCounter2[i] = glob.colonization.acropolis.goodsCounter2[i] + 1
          game.player.print("Not enough goods in an acropolis!")
        end
        glob.colonization.acropolis[i].getinventory(1).remove{name="goods2", count = goodsNeeded}

        goodsNeeded = math.ceil(citizen * 0.1)
        if goodsNeeded <= goods3 then
          glob.colonization.acropolis.goodsCounter3[i] = glob.colonization.acropolis.goodsCounter3[i] - 1
        else
          glob.colonization.acropolis.goodsCounter3[i] = glob.colonization.acropolis.goodsCounter3[i] + 1
          game.player.print("Not enough goods in an acropolis!")
        end
        glob.colonization.acropolis[i].getinventory(1).remove{name="goods3", count = goodsNeeded}

        if (glob.colonization.acropolis.goodsCounter1[i] >= 5) or (glob.colonization.acropolis.goodsCounter2[i] >= 7) or (glob.colonization.acropolis.goodsCounter3[i] >= 10) then
          missingGoods = missingGoods + 1
        end

        if missingGoods > 0 then
          game.player.print("Not enough goods in an acropolis! Citizen converted!!!")
          glob.colonization.acropolis[i].getinventory(1).remove{name="citizen-token", count = 1}
          glob.colonization.acropolis[i].getinventory(1).insert{name="settler-token", count = 1}
          glob.colonization.acropolis.goodsCounter1[i] = 0
          glob.colonization.acropolis.goodsCounter2[i] = 0
          glob.colonization.acropolis.goodsCounter3[i] = 0
          missingGoods = 0
        end       
      end -- glob.colonization.acropolis[i].getitemcount("citizen-token") > 0 then
    end -- for i = 1 , glob.colonization.acropolisCount , 1 do
  end -- function

acropolisTaxes =
  function()
    for i = 1 , glob.colonization.acropolisCount , 1 do
      if (glob.colonization.acropolis[i].getitemcount("citizen-token") > 0) then
        local citizenCount = glob.colonization.acropolis[i].getitemcount("citizen-token")
        local taxes = citizenCount * 10
        glob.colonization.acropolis[i].getinventory(1).insert{name="col-money", count = taxes}
      end
    end
  end
