data:extend(
{
  {
    type = "smart-container",
    name = "outpost",
    icon = "__Colonization__/graphics/icons/outpost.png",
    flags = {
      "placeable-neutral",
      "player-creation"
    },
    minable = {
      hardness = 0.2,
      mining_time = 0.5,
      result = "outpost"
    },
    max_health = 100,
    collision_box = {
      {
        -8.0,
        -6.0
      },
      {
        8.0,
        6.0
      }
    },
    selection_box = {
      {
        -8.0,
        -6.0
      },
      {
        8.0,
        6.0
      }
    },
    inventory_size = 10,
    picture = {
      filename = "__Colonization__/graphics/entity/Colonization/outpost.png",
      priority = "medium",
      width = 512,
      height = 384,
    }
  },

  {
    type = "smart-container",
    name = "merchant",
    icon = "__Colonization__/graphics/icons/merchant.png",
    flags = {
      "placeable-neutral",
      "player-creation"
    },
    minable = {
      hardness = 0.2,
      mining_time = 0.5,
      result = "merchant"
    },
    max_health = 100,
    collision_box = {
      {
        -8.5,
        -7.0
      },
      {
        8.5,
        7.0
      }
    },
    selection_box = {
      {
        -8.5,
        -7.0
      },
      {
        8.5,
        7.0
      }
    },
    inventory_size = 10,
    picture = {
      filename = "__Colonization__/graphics/entity/Colonization/merchant.png",
      priority = "medium",
      width = 544,
      height = 448,
    }
  },

  {
    type = "smart-container",
    name = "acropolis",
    icon = "__Colonization__/graphics/icons/acropolis.png",
    flags = {
      "placeable-neutral",
      "player-creation"
    },
    minable = {
      hardness = 0.2,
      mining_time = 0.5,
      result = "acropolis"
    },
    max_health = 100,
    collision_box = {
      {
        -16.0,
        -14.0
      },
      {
        16.0,
        12.0
      }
    },
    selection_box = {
      {
        -16.0,
        -14.0
      },
      {
        16.0,
        12.0
      }
    },
    inventory_size = 20,
    picture = {
      filename = "__Colonization__/graphics/entity/Colonization/acropolis.png",
      priority = "extra-high",
      width = 1024,
      height = 1212,
      shift = {0.0, -5.875}
    }
  },

  {
    type = "assembling-machine",
    name = "farm",
    icon = "__Colonization__/graphics/icons/farm.png",
    flags = {
      "placeable-neutral",
      "player-creation"
    },
    minable = {
      hardness = 0.2,
      mining_time = 0.5,
      result = "farm"
    },
    max_health = 100,
    collision_box = {
      {
        -2.0,
        -2.0
      },
      {
        2.0,
        2.0
      }
    },
    selection_box = {
      {
        -2.0,
        -2.0
      },
      {
        2.0,
        2.0
      }
    },
    animation = {
      filename = "__Colonization__/graphics/entity/Colonization/farm.png",
      priority = "medium",
      frame_width = 128,
      frame_height = 156,
      frame_count = 1,
      line_length = 1,
      shift = {0.0, -0.5}
    },
    crafting_categories = {
      "colonization-farming"
    },
    effectivity = 1,
    energy_source = {
      type = "electric",
      input_priority = "secondary"
    },
    energy_usage_per_tick = 0.1,
    ingredient_count = 1
  },

  {
    type = "assembling-machine",
    name = "cargo-pad",
    icon = "__Colonization__/graphics/icons/cargo-pad.png",
    flags = {
      "placeable-neutral",
      "player-creation"
    },
    minable = {
      hardness = 0.2,
      mining_time = 0.5,
      result = "cargo-pad"
    },
    max_health = 100,
    collision_box = {
      {
        -2.0,
        -2.0
      },
      {
        2.0,
        2.0
      }
    },
    selection_box = {
      {
        -2.0,
        -2.0
      },
      {
        2.0,
        2.0
      }
    },
    animation = {
      filename = "__Colonization__/graphics/entity/Colonization/cargo-pad.png",
      priority = "medium",
      frame_width = 128,
      frame_height = 128,
      frame_count = 1,
      line_length = 1,
      shift = {0.0, 0.0}
    },
    crafting_categories = {
      "colonization-cargo"
    },
    effectivity = 1,
    energy_source = {
      type = "electric",
      input_priority = "secondary"
    },
    energy_usage_per_tick = 0.1,
    ingredient_count = 1
  },

  
  {
    type = "assembling-machine",
    name = "goods-maker",
    icon = "__Colonization__/graphics/icons/goods-maker.png",
    flags = {
      "placeable-neutral",
      "player-creation"
    },
    minable = {
      hardness = 0.2,
      mining_time = 0.5,
      result = "goods-maker"
    },
    max_health = 100,
    collision_box = {
      {
        -2.0,
        -2.0
      },
      {
        2.0,
        2.0
      }
    },
    selection_box = {
      {
        -2.0,
        -2.0
      },
      {
        2.0,
        2.0
      }
    },
    animation = {
      filename = "__Colonization__/graphics/entity/Colonization/goods-maker.png",
      priority = "medium",
      frame_width = 128,
      frame_height = 128,
      frame_count = 1,
      line_length = 1,
      shift = {0.0, 0.0}
    },
    crafting_categories = {
      "colonization-goods"
    },
    effectivity = 1,
    energy_source = {
      type = "electric",
      input_priority = "secondary"
    },
    energy_usage_per_tick = 0.1,
    ingredient_count = 1
  },

  {
    type = "assembling-machine",
    name = "food-maker",
    icon = "__Colonization__/graphics/icons/food-maker.png",
    flags = {
      "placeable-neutral",
      "player-creation"
    },
    minable = {
      hardness = 0.2,
      mining_time = 0.5,
      result = "food-maker"
    },
    max_health = 100,
    collision_box = {
      {
        -2.0,
        -2.0
      },
      {
        2.0,
        2.0
      }
    },
    selection_box = {
      {
        -2.0,
        -2.0
      },
      {
        2.0,
        2.0
      }
    },
    animation = {
      filename = "__Colonization__/graphics/entity/Colonization/food-maker.png",
      priority = "medium",
      frame_width = 128,
      frame_height = 128,
      frame_count = 1,
      line_length = 1,
      shift = {0.0, 0.0}
    },
    crafting_categories = {
      "colonization-food"
    },
    effectivity = 1,
    energy_source = {
      type = "electric",
      input_priority = "secondary"
    },
    energy_usage_per_tick = 0.1,
    ingredient_count = 1
  }
}
)
