data:extend(
{
  {
    type = "technology",
    name = "food-production-1",
    icon = "__Colonization__/graphics/tech/food-production.png",
    effects = {
      {
        type = "unlock-recipe",
        recipe = "farm"
      }
    },
    prerequisites = {
      "rocket-defense"
    },
    unit = {
      count = 500,
      ingredients = {
        {"science-pack-1", 1},
        {"science-pack-2", 1},
        {"science-pack-3", 1}
      },
      time = 20
    },
    upgrade = "true"
  },

  {
    type = "technology",
    name = "food-production-2",
    icon = "__Colonization__/graphics/tech/food-production.png",
    effects = {
      {
        type = "unlock-recipe",
        recipe = "food-maker"
      }
    },
    prerequisites = {
      "food-production-1"
    },
    unit = {
      count = 500,
      ingredients = {
        {"science-pack-1", 1},
        {"science-pack-2", 1},
        {"science-pack-3", 1}
      },
      time = 20
    },
    upgrade = "true"
  },

  {
    type = "technology",
    name = "export-nation-1",
    icon = "__Colonization__/graphics/tech/export-nation.png",
    effects = {
      {
        type = "unlock-recipe",
        recipe = "goods-maker"
      }
    },
    prerequisites = {
      "rocket-defense"
    },
    unit = {
      count = 250,
      ingredients = {
        {"science-pack-1", 1},
        {"science-pack-2", 1},
        {"science-pack-3", 1}
      },
      time = 15
    },
    upgrade = "true"
  },

  {
    type = "technology",
    name = "export-nation-2",
    icon = "__Colonization__/graphics/tech/export-nation.png",
    effects = {
      {
        type = "unlock-recipe",
        recipe = "cargo-pad"
      }
    },
    prerequisites = {
      "export-nation-1"
    },
    unit = {
      count = 250,
      ingredients = {
        {"science-pack-1", 1},
        {"science-pack-2", 1},
        {"science-pack-3", 1}
      },
      time = 15
    },
    upgrade = "true"
  },

  {
    type = "technology",
    name = "colonization-1",
    icon = "__Colonization__/graphics/tech/colonization.png",
    effects = {
      {
        type = "unlock-recipe",
        recipe = "outpost"
      }
    },
    prerequisites = {
      "export-nation-2","food-production-2" 
    },
    unit = {
      count = 500,
      ingredients = {
        {"science-pack-1", 1},
        {"science-pack-2", 1},
        {"science-pack-3", 1}
      },
      time = 25
    },
    upgrade = "true"
  },

  {
    type = "technology",
    name = "colonization-2",
    icon = "__Colonization__/graphics/tech/colonization.png",
    effects = {
      {
        type = "unlock-recipe",
        recipe = "merchant"
      }
    },
    prerequisites = {
      "colonization-1" 
    },
    unit = {
      count = 500,
      ingredients = {
        {"science-pack-1", 1},
        {"science-pack-2", 1},
        {"science-pack-3", 1}
      },
      time = 25
    },
    upgrade = "true"
  },

  {
    type = "technology",
    name = "colonization-3",
    icon = "__Colonization__/graphics/tech/colonization.png",
    effects = {
      {
        type = "unlock-recipe",
        recipe = "acropolis"
      }
    },
    prerequisites = {
      "colonization-2" 
    },
    unit = {
      count = 500,
      ingredients = {
        {"science-pack-1", 1},
        {"science-pack-2", 1},
        {"science-pack-3", 1}
      },
      time = 25
    },
    upgrade = "true"
  },

}
)